; Make A Shit 
; Game 76 in 1K hires


llen 	equ 16
nrlin	equ 18
clin    equ nrlin-1
                                                                
           ORG  #4009             ; #4009                        
                                                                
; program starts here, both BASIC and machinecode               
basic      EX   AF,AF'            ; delay intrupt,opcode no bit 6
           LD   H,B               ; preset for 48K bug to #40   
           JR   init0             ; continue where room         
                                                                
           DEFB 236,212,28        ; The BASIC                   
           DEFB 126               ; fully placed over sysvar    
           DEFB 143,0,18          ; start BASIC=#4009 also MC   
                                                                
           DEFW last              ; needed by loading           
chadd      DEFW last-1                                          
xptr       DEFW 0                                               
stkbot     DEFW last                                            
stkend     DEFW last                                            
berg       DEFB 0                                               
mem        DEFW 0                                               
           DEFB 128                                             
                                                                
           DEFB 0,0,0                                           
                                                                
; all above reusable AFTER loading                              
                                                                
lastk      DEFB 255,255,255       ; used by ZX81                
margin     DEFB 55                ; used by ZX81                
nxtlin     DEFW basic             ; reusable after load         
                                                                
init0   nop   			  ; in model IX HR is set but not in this game
	LD   hl,hr                ; hl only filler in this game      
; lowbyte over flagx which resets bit 5 on load                 
; HR must be set on right address or game crashes               
                                                                
movesdone  LD   E,L               ; DE now #xx.L                
                                                                
taddr      DEFW 0                 ; used by ZX81 on LOAD only   
                                  ; unharmed code               
                                                                
           LD   B,6               ; copy >1K code               
                                                                
frames     DEFB #16+1             ; LD D,n , after LOAD -1      
           DEFB #C0               ; highbyte must have bit 7 set
coords     LDIR                   ; DE now #C0.L  = Hl +#8000 NO 48K BUG IN THIS GAME   
                                  ; fix 48K bug before display  
prcc       JP   init              ; continue to mainprog        
                                                                
cdflag     DEFB 64                ; used by ZX81                
                                                                
; Place ANY code to fill up to #4040                            

; hrscr placed so that a line ends at #4080
; this screen holds 16 udg's of shit which only display when
; LBUF is set on for display.
	db 0
hrscr	db 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56, 56,0
	db 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20,0
	db 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18,0
	db 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34,0
	db 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77, 77,0
	db 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65, 65,0
	db 127,127,127,127,127,127,127,127,127,127,127,127,127,127,127,127

left	equ #4000-fieldc+leftc
right	equ #4000-fieldc+rightc
up	equ #4000-fieldc+upc
down	equ #4000-fieldc+downc
rseed	equ nxtlin-rnd1+rseedc


keytab	db %11111011	; Q
	db %00000001
	db up mod 256
	
	db %11111101	; A
	db %00000001    	
	db down mod 256

	db %11011111	; O
	db %00000010    	
	db left mod 256

	db %11011111	; P
	db %00000001    	
	db right mod 256

	db 0		; endmarker

keymov	ld hl,keytab-1
fkey	inc hl
	ld a,(hl)
	or a 
	ret z
	in a,(254)
	cpl
	inc hl
	and (hl)
	inc hl
	jr z,fkey
	ld l,(hl)
cllhl	jp (hl)



;		dog, 	catcher, shit 
graph	db 	48,	55	,56
	db 	209,	117	,20
	db 	113,	55	,18
	db 	63,	18	,34
	db 	127,	126	,77
	db 	127,	58	,65
	db 	66,	40	,127


hr      LD   HL,lowres+#8000   ; the lowres display          
 
        LD   BC,#311           ; minimum needed #11          
	LD   A,#1E                                           
	LD   I,A  

	LD   A,#FB                                           
	CALL #2B5              ; show lowres screen          

	ex (sp),hl
	ex (sp),hl

	inc bc
	cp (hl)
	cp (hl)

	ld (savesp+1),sp       ; save game stackpointer

	ld d,b			; first write over ROM

	exx
	ld hl,lbuf1+#8000-llen-2          
		                	
; the hr part                                                   
	ld sp,dispstack

	ld b,nrlin+1			; nr of rows +1			

bloop	ld de,llen+2
	add hl,de		; next LBUF
	exx
	dec de			; repair last change in display
	ld a,(hl)
	ld (de),a
	ld a,e
	sub b
	ld e,a
	ldi
	exx
	ld c,7
	dec b
	jp z,savesp		; end of screen reached
	exx	

	ld hl,graph		; start of graphics for new line
	ld de,hrscr		; the full screen from the start
	ld a,d
	ld i,a			; first time set highbyte, next times delay only

	cp (hl)
	dec bc

	pop bc			; get positions of dog and catcher on this line

	ex (sp),hl		; fill the line, topline is always a space line
	ex (sp),hl
	cp 255			; we need a carry in 7 tstates

	ld a,c 			; position of dog on line
	adc a,b			; add relative position of catcher to it +1 for JP (HL)
	exx
	ld d,a			; save relative displacement from start of line in D'
	exx
	ld a,e			; get start of LBUF
	add a,c			; add position of dog
	ld c,h			; set C out of range o reach 0 with LDI to keep B unchanged
	ld ix,cloop		; RETURN from display
	
	jr cin			; jump into second line to display

lowres	db 118
score	db "U"-27,"D"-27,"L"-27,"R"-27,0
	db "M"+x,"A"+x,"K"+x,"E"+x,22+128,"A"+x,22+128,"S"+x,"H"+x,"I"+x,"T"+x,0
;	db "C"+x,"A"+x,"T"+x,"C"+x,"H"+x,22+128,"A"+x,22+128,"D"+x,"O"+x,"G"+x,0
hiscore	db 22,35,34,22
	db 118,#e9

cloop	jr z,bloop		; test end of full line display
	exx
	dec de			; undo changes to shit from display dog and catcher
	ld a,(hl)
	ld (de),a
	ld a,e
	sub b
	ld e,a
	ldi

	add a,llen+1		; go to next LBUF-data

cin	ld e,a			; save datapointer dog on next line
	add a,b			; add displacement catcher in A only
	ldi			; write DOG to dataline

	ld e,a			; set catcher pointer
	ldi			; write catcher on the line
	exx
	
	sub d			; repair A to begin of display
	dec c			; another line done
	ld r,a
	jp (hl)			; do the display with current LBUF


; fixed end of HR-routine
savesp	ld sp,0                ; game stackpointer                       
	CALL #292              ; back from intrupt           	
	CALL #220                                            
	LD   IX,hr                                           
	JP   #2A4                                            

lbuf2 equ lbuf1+18

; stack to get right displaybuffer during intrupt
dispstack
	block nrlin*2,0

deadt	ld hl,(catcpos+1)	; get xy catcher
	or a		
	sbc hl,bc		; test against xy dog
	ret nz			; not captured here
	pop hl			; GAME OVER, drop RET
		  
eog	ld hl,score-1
	ld de,hiscore-1
	ld bc,5
same	dec c
	inc de
	inc hl
	ld a,(de)
	cp (hl)
	jr z,same
	call c,#19f9


start	ld a,191
	in a,(254)
	rra
	jr c,start		; Test NL only
	
	ld l,score mod 256 	; H always OK
ersc	ld (hl),28		; Set score to "0000"
	inc hl
	inc (hl)
	dec (hl)
	jr nz,ersc

	ld hl,lbuf1
cls	ld (hl),#40		; do not show field
	inc hl
sklf	ld a,(hl)		; get next field
	cp #dd			; test end of line
	jr c,cls		; normal field
	inc l
	jr nz,sklf		; test end of screen

	ld hl,#010f
	ld (catcpos+1),hl
	ld a,l
	ld (mptime+1),a

	ld bc,nrlin*256		; bottom of row

ploop	call #4000
	ld (hl),b		; show dog
	
; show dog
	ld hl,deadt-1		; the last position of catcher
	ld de,nrlin*256+nrlin	; nr of lines in the game
erdisp	ld (hl),0		; no displacement from dog on this row
	dec hl			; if an intrupt occurs then no crash
	ld a,b
	cp d
	ld a,c			; preset x-coordinate on this line
	jr z,seta		; we show dog on this line
	ld a,255		; we need to set NO SHOW-coordinate
seta	ld (hl),a		; set dogdisplay of this line
	dec hl
	dec d
	jr nz,erdisp		; set all display options

; show catcher
	push bc			; save coordinates dog
catcpos ld bc,#403		; get coordinates catcher
setca	inc hl
	ld d,(hl)		; get position dog on this line
	inc hl
	ld a,nrlin+1
	sub b			; test what to set
	cp e
	ld a,c
	jr z,setc		; we show catcher 
	ld a,#ff		; coordinate NO SHOW catcher 
setc	sub d			; calculate displacement to dog
	ld (hl),a		; set displacement to dog
	dec e
	jr nz,setca		; do all lines	

	call #4000
	ld (hl),d		; show catcher
	pop bc
	push hl			; save catcherposition

	ld hl,frames
	ld a,(hl)
	sub 4
wfr	cp (hl)
	jr nz,wfr

	pop hl
	ld (hl),#40		; erase the shit
	

; move player
	
mv12	ld a,2
	dec a
	jr nz,domove
mptime	ld a,2
domove	ld (mv12+1),a
	call nz,keymov
	
	call deadt		; test if catcher has dog
	
; move catcher
	push bc
	ld a,#28		; jr z opcode

test2	ld (test),a
	call nxtlin		; get a random number
	and 3
	or 4			; at least 4 directions to test
	ld d,a


dirlp	ld a,d
	and 3			; 0-3
olddir	cp 255			; test oldmov
	jr z,test+2		; no move, C off

	ld bc,(catcpos+1)
	ld e,a			 
	add a,a
	add a,e
	ld e,a
	ld hl,keytab+2
	add a,l
	ld l,a
	ld l,(hl)
	call cllhl		; do the move
	ld a,d			; save D
	call c,#4000		; a valid move has C
	ld d,a
	bit 6,(hl)		; illegal move will have LD E,r, bit 6 set

test	jr z,moveok		

	dec d
	jr nz,dirlp		; do always all directions

; we did 4 moves, but all not to shit, so next ANY move is allowed
	ld a,#38		; jr c opcode
	jr test2
	
moveok	ld (catcpos+1),bc
	and 3
	xor 1			; don't allow move back next time
	ld (olddir+1),a
	bit 6,(hl)
	jr nz,nosc
	ld hl,score+4
	db 1			; skip LD (HL),28
ten	ld (hl),28
	dec hl
	ld a,l
	cp score mod 256 +1
	jr nz,add1
	ld de,mptime+1
	ld a,(de)
	dec a
	dec a
	jr z,add1
	inc a
	ld (de),a
add1	inc (hl)
	ld a,(hl)
	cp 38
	jr z,ten
nosc	pop bc
	call deadt		; test if catcher has dog	

	jp ploop


x	equ 101

space   equ #4400-nrlin*llen-nrlin*2-$

	block space,0

spmas

lbuf1	block llen,#40		; The displaybuffer is copied 19x
	jp (ix)

; this part of memory becomes displaybuffers, but first
; it is used to copy routines over sysvar and redefine keys

init	ld sp,spmas		; StackPointer MAKE A SHIT
	ld hl,lowres
	ld (basic+3),hl		; use a lowresscreen during redefine

	ld hl,score		; after loading score holds redefkeys
	ld de,keytab
w4up	inc a			; test no key pressed
	set 7,(hl)		; light which direction
w4down	ld bc,(lastk)		; get last input
	ld a,c			; get inport or nokey
	jr nz,w4up
	inc a			; test for down
	jr z,w4down
	dec a			; undo change
	ld (de),a		; save inport in keytable
	in a,(254)		; read keyboard
	or 224			; only keybit is now down
	cpl			; invert
	inc de		
	ld (de),a		; save result for key
	inc de
	inc de
	ld (hl),22		; erase key, but it must be >0 
	inc hl
	ld a,(hl)		; test end of score
	or a
	jr nz,w4up		; do all keys

	ex af,af'		; delay intrupt to create time to copy lbuf's

	ld hl,fieldc		; field and directions over sysvar
	ld de,#4000
	ld bc,37
	ldir

	ld hl,rnd1		; random routine
	ld e,nxtlin mod 256	; to be set over sysvar
	ld c,17			; copy random routine
	ldir

	ld hl,eog
	push hl			; set startpoint of game
	ld ix,hr
	ld hl,lbuf1		; make copys of buffers
	ld de,lbuf2
	ld bc,clin*llen+clin*2
	jp #19f9


; field and right are copied over the sysvar, saves 35 bytes!
fieldc 	push bc
	ld hl,lbuf1-llen-2
	ld de,llen+2
fline	add hl,de
	djnz fline
	add hl,bc
	pop bc
	scf			; carry needed to keep C from start
	ret

rightc 	ld e,c
	inc c
	db #3a			; LD A,(NN) to skip LD E,C and DEC C

leftc	ld e,c
	dec c				
	ld a,c
	cp llen			; test valid horizontal move
	ret c
	ld c,e
	ret

downc	ld e,b
	inc b
	db #3a			; again LD A,(NN) trick

upc	ld e,b
	dec b
	ld a,b
	dec a
	cp nrlin		; test valid vertical move
	ret c
	ld b,e
	ret


; randomroutine placed over sysvar
rnd1 	ld hl,rseed 			; seed pointer 
	ld a,(hl) 			; get seed RRCA ; a=a/2 
	rrca 				; a=a/2 
	rrca
	rrca
	xor 31 				; swap low bits 
	add a,(hl) 			; add seed 
	db 17 				; hide frames in DE 
	dw 65535 			; frames used by zx81 
	add a,e 			; add framecounter 
	ld (hl),a 			; save new seed 
	ret 
 
rseedc equ $
vars	db 128
last	equ $
 